User without permissions to view required project custom fields cannot create new projects
Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Marius BĂLTEANU % Done: 0%

Category: Projects Estimated time: 0.00 hour

Target version: 4.1.7   

Resolution: Fixed Affected version:  

Description

Hello

On a project when a custom field is marked as mandatory but not visible for certain roles, users of these roles can no longer create a

project.

https://github.com/redmine/redmine/pull/135

Associated revisions

Revision 21488 - 2022-03-21 23:13 - Marius BĂLTEANU

Skip validation of required custom fields when creating a project if user does not have permissions to see those custom fields (#36593).

Patch by mathieu-mbru.

Revision 21489 - 2022-03-21 23:16 - Marius BĂLTEANU

Revert undesired changes (#36593)

Revision 21491 - 2022-03-22 07:52 - Marius BĂLTEANU

Merged r21488 and r21489 to 4.2-stable (#36593).

Revision 21492 - 2022-03-22 07:52 - Marius BĂLTEANU

Merged r21488 and r21489 to 4.1-stable (#36593).

History

#1 - 2022-02-10 03:27 - Mizuki ISHIKAWA

+1

Thanks for reporting the problem and for sharing the code.

I was able to reproduce the problem.

Here are the steps to reproduce the problem.

bundle exec rake db:fixtures:load

Log in as admin user

Custom fields » Projects » New custom field

✓ required

✓ to these roles only: Manager

Log in as jsmith user

New project => save

The error message "Test cannot be blank" is displayed.

In https://github.com/redmine/redmine/pull/135 , a pull request is proposed to skip the validation of required custom fields when a user who does not

have permission to see them tries to create a project.

The same mechanism is already implemented in Issue, so I think it's good to add this pull request code to Redmine.

Issue: https://github.com/redmine/redmine/blob/eb868ad9324e65942e8ad0ccd0a035d801a93864/app/models/issue.rb#L833

#2 - 2022-03-09 10:30 - Vincent Robert

- Category set to Projects

- Status changed from New to Confirmed

- Target version set to Candidate for next minor release
#3 - 2022-03-21 12:36 - Marius BĂLTEANU

- Assignee set to Marius BĂLTEANU

#4 - 2022-03-21 23:10 - Marius BĂLTEANU

- Subject changed from unexpected behavior when a user create a project with required custom field  to Unexpected behavior when a user create a

project with required custom field 

- Target version changed from Candidate for next minor release to 4.1.7

#5 - 2022-03-21 23:16 - Marius BĂLTEANU

- Status changed from Confirmed to Resolved

Fix committed, thanks!

#6 - 2022-03-22 07:53 - Marius BĂLTEANU

- Subject changed from Unexpected behavior when a user create a project with required custom field  to User without permissions to view required

project custom fields cannot create new projects

- Status changed from Resolved to Closed

- Resolution set to Fixed
